SystemOrganization addCategory: #'Phidget-Core'!

Object subclass: #PhdCrComponent
	instanceVariableNames: 'phidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrComponent class methodsFor: 'instance creation' stamp: 'lk 6/1/2009 17:19'!
newWith: phidget

	^ self new
		setParent: phidget! !

!PhdCrComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 17:21'!
setParent: parent
	"Set my 'phidget' instance variable to the given one.
	If I already have a parent, do nothing."
	
	phidget ifNil: [ phidget := parent ].! !

PhdCrComponent subclass: #PhdCrMultiComponent
	instanceVariableNames: 'index nextLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

PhdCrMultiComponent subclass: #PhdCrCompAnalogSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompAnalogSensor class methodsFor: 'multi-component' stamp: 'lk 6/1/2009 19:21'!
primComponentCount: phidgetHandle
	"Gets the number of sensors for a phidget analog sensors component."

	<primitive: 'primNumAnalogSensors' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/1/2009 19:02'!
primGetSensitivity: phidgetHandle at: index

	<primitive: 'primGetIndexedIntegerSensitivity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/1/2009 19:02'!
primSetSensitivity: phidgetHandle at: index to: anInteger

	<primitive: 'primSetIndexedIntegerSensitivity' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor class methodsFor: 'primitives' stamp: 'lk 6/1/2009 19:03'!
primValue: phidgetHandle at: index
	"Gets the sensor value (0-1000) at the analog input with the given index."

	<primitive: 'primGetAnalogSensorValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompAnalogSensor methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 18:50'!
getSensitivity

	^ self class
		primGetSensitivity: phidget handle
		at: index - 1! !

!PhdCrCompAnalogSensor methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 18:53'!
setSensitivity: anInteger
	"Sets the sensor change trigger of the sensor to 'anInteger'.
	a sensor change block will only be evaluated if the change is more than this trigger."
	
	(anInteger isInRange: (0 to: 100)) ifFalse: [ ^ false ].

	^ self class
		primSetSensitivity: phidget handle
		at: index - 1
		to: anInteger! !

!PhdCrCompAnalogSensor methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 19:01'!
value
	"Gets the current value of the sensor (integer from 0 to 1000)."
	
	^ self class
		primValue: phidget handle
		at: index - 1! !

PhdCrMultiComponent subclass: #PhdCrCompDigitalInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompDigitalInput class methodsFor: 'multi-component' stamp: 'lk 6/1/2009 20:31'!
primComponentCount: phidgetHandle
	"Gets the number of inputs for a phidget digital input component."

	<primitive: 'primNumDigitalOutputs' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalInput class methodsFor: 'primitives' stamp: 'lk 6/1/2009 20:32'!
primValue: phidgetHandle at: index
	"Gets the input value (0/1 = on/off) at the digital input with the given index."

	<primitive: 'primGetDigitalInputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalInput methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:14'!
value
	"Gets the current value of the input (true/false = on/off)."
	
	^ (self class
		primValue: phidget handle
		at: index - 1) > 0! !

PhdCrMultiComponent subclass: #PhdCrCompDigitalOutput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrCompDigitalOutput class methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:30'!
primComponentCount: phidgetHandle
	"Gets the number of outputs for a phidget digital output component."

	<primitive: 'primNumDigitalOutputs' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalOutput class methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:31'!
primGetValue: phidgetHandle at: index
	"Gets the output value (0/1 = on/off) at the digital output with the given index."

	<primitive: 'primGetDigitalOutputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalOutput class methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:34'!
primSetValue: phidgetHandle at: index to: value
	"Sets the output value (0/1 = on/off) at the digital output with the given index to the given value."

	<primitive: 'primSetDigitalOutputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrCompDigitalOutput methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:30'!
value
	"Gets the current value of the output (true/false = on/off)."
	
	^ (self class
		primGetValue: phidget handle
		at: index - 1) > 0! !

!PhdCrCompDigitalOutput methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:33'!
value: aBoolean
	"Sets the current value of the output (true = on, false = off)."
	
	| number |
	aBoolean
		ifTrue: [ number := 1 ]
		ifFalse: [ number := 0 ].
	^ self class
		primSetValue: phidget handle
		at: index - 1
		to: number! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/1/2009 18:24'!
componentCount: phidget
	"Returns the number of components in a multicomponent phidget.
	Uses a primitive the subclasses must define. This primitive can for example call GetNumSensors in an InterfaceKit."
	
	phidget attached
		ifTrue: [ ^ self primComponentCount: phidget handle ].
	 ^ 0! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/1/2009 18:40'!
getListFor: phidget
	"Answers a LinkedList of my class, with self componentCount elements each initialized with its index in the list."

	| list size |
	list := LinkedList new.
	size := self componentCount: phidget.
	
	(1 to: size) do: [ :i |
		list add: (self newWith: phidget index: i) ].
	^ list! !

!PhdCrMultiComponent class methodsFor: 'instance creation' stamp: 'lk 6/1/2009 18:19'!
newWith: phidget index: index

	^ (self newWith: phidget)
		setIndex: index! !

!PhdCrMultiComponent class methodsFor: 'multi-component' stamp: 'lk 6/1/2009 18:26'!
primComponentCount: phidgetHandle
	"Gets the number of components for a phidget multi component."

	self subclassResponsibility.! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:38'!
nextLink

	^ nextLink! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:38'!
nextLink: aMultiComponent

	nextLink := aMultiComponent.! !

!PhdCrMultiComponent methodsFor: 'accessing' stamp: 'lk 6/1/2009 18:17'!
setIndex: aNumber
	"Set my 'index' instance variable to the given one.
	If I already have an index, do nothing."
	
	index ifNil: [ index := aNumber ].! !

Object subclass: #PhdCrPhidget
	instanceVariableNames: 'opened handle semaphores userProcessBlocks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

PhdCrPhidget class
	instanceVariableNames: 'SystemCallbacks'!

!PhdCrPhidget commentStamp: 'lk 6/1/2009 17:09' prior: 0!
I am an abstract class that provides some primitives and methods for Phidget support. Please read the comments of my subclasses to find more information how to use Phidgets in Squeak.

Instance Variables
	handle:					<ByteArray>
	opened:					<Boolean>
	userProcessBlocks:	<Dictionary> (Symbol -> Block)
	semaphores:				<Dictionary> (Symbol -> Semaphore)
Class Instance Variables
	SystemCallback:		<Dictionary> (Symbol -> Symbol)
	
handle
	- a ByteArray that contains the Phidget handle for the C API. Every primitive (except the one where the handle is created) needs this ByteArray to let the C API know about which Phidget it is currently talking.

opened
	- true, if the Phidget was opened - Squeak is able to communicate with the hardware. This does not mean there is a Phidget attached.
	- false, if the Phidgets was not opened or was opened and then closed.

semaphores
	- A Dictionary with entries of the following form: aSymbol -> aSemaphore.
	aSymbol may be #Attach, #Detach, #Error for Phidgets in general. Other symbols may exist for phidget specific support in my subclasses. My classes method 'knownCallback' answers a list of callbacks I know.
	I use this dictionary to handle the callbacks from the Phidget C API.
	These semaphores can be registered for certain events (like the attach event) - so that the C API signals is if the event occours. These semaphores are used in my callbackProcess method.

userProcessBlocks
	- a Dictionary with entries of the following form: aSymbol -> aBlock.
	The symbols are equivalent to the symbols used in the semaphores dictionary.
	I use this dictionary to handle the callbacks from the Phidget C API.
	Each time a semaphore from the semaphores dictionary was signaled from the C API, I evaluate the corresponding block from this dictionary in the callbackProcess method.

SystemCallbacks
	My class has a method called 'systemCallbacks'. This Dictionary is similar to the userProcessBlocks: It maps from callbackNames to message selectors. Those messages willbe sent when the semaphore at 'callbackName' is signaled.
	In contrast to userProcessBlocks this Dictionary is immutable to the user. Currently it is only used for initializing and deleting phidget components an attaching/detaching (see below).

About Components:
	A phidget can have several components, e.g. a List of outputs or a LED. Those components derive from the PhdCrComponent class. See its documentation to lern more about them.
	When a phidget is attached, it initializes its components using 'initializeComponents'. When the phidget is detached or closed, 'deleteComponents' deletes them again.
	As there are different Phidgets per phidget class, the components can differ. A InterfaceKit can for instance have 8 sensors, others might have none. The implementation of initializeComponents must be aware of that.
	!

PhdCrPhidget class
	instanceVariableNames: 'SystemCallbacks'!

PhdCrPhidget subclass: #PhdCrInterfaceKit
	instanceVariableNames: 'sensors inputs outputs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrInterfaceKit commentStamp: 'lk 6/1/2009 17:12' prior: 0!
I am a representation of a Phidget called 'Interface Kit' in Squeak.
To use a Interface Kit, create a new instance and open a connection to the hardware board with:
	ifKit := PhdCrInterfaceKit new.
	ifKit openAny.
Send me a block to be evaluated every time the hardware board was attached, detached, an error occoured, a sensor value was changed, an input value was changed or an output value was changed. For example:
	ifKit
		onAttachDo: [ Transcript show:'servo was attached!!;cr' ];
		onDetachDo: [ Transcript show:'servo was detached!!;cr' ];
		onSensorChangeDo: [ Transcript show:'A sensor changed it's value!!' ].

Depending on which hardware is attached it is possible to attach zero or more analog sensors (, digital inputs or digital outputs) to the board. To get the number of available sensors send 'sensorCount' ('inputCount', 'outputCount'). Every sensor can be accessed by an index adressing it. Valid indices are greater or equal than 1 and less or equal than the number of available sensors (sensorCount).
To get the value of a sensor, call 'sensorValue: index'. The value will be a number between 0 and 1000.
The input and output values are boolean and may be read by: 'outputValue: index' or 'inputValue: index'.
Set an output value to true/false with 'setOutputValue: aBoolean at: index'.

IMPORTANT:
After using the Interface Kit it is important to close the connection to the hardware by sending 'close':
	ifKit close.

NOTE:
The block for onSensorChange will be evaluated only if the change is greater than a number called sensitivity. Example: A light sensor probably changes its value continuously. We want to know greater changes only, so we set the sensitivity to 50. So the sensor change block will be evaluated only if the change is greater than 50. To set the sensitivity, call 'sensitivity: aNumber to: index'.
!

!PhdCrInterfaceKit class methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:23'!
knownCallbacks
	"Returns a list of callback names (#symbols) the InterfaceKit knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #SensorChange #InputChange #OutputChange )! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:04'!
deleteComponents
	"This method is called when the InterfaceKit is detached. It delets previously in 'initializeComponents' built components: sensors, inputs, outputs."

	sensors := nil.
	inputs := nil.
	outputs := nil.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 17:43'!
handle

	^ handle! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:45'!
initializeComponents
	"This method is called when an InterfaceKit is attached. It initializes its components: sensors, inputs, outputs.
	The components will be deleted in 'deleteComponents' on detaching."
	
	sensors := PhdCrCompAnalogSensor getListFor: self.
	inputs := PhdCrCompDigitalInput getListFor: self.
	outputs := PhdCrCompDigitalOutput getListFor: self.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:17'!
inputCount
	"Returns the number of inputs that may be attached to the Interface Kit."
	
	self attached
		ifTrue: [ ^ self primNumInputs: handle ].
	^ 0! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 5/3/2009 11:28'!
inputIndexIsInRange: index
	"Returns true if 1<=index<=sensorCount.
	Every time a primitive is used that needs the input index, this method should be used to check if the index is in the correct range."
	
	index isInteger ifFalse: [ ^ false ].
	^ ( 1 <= index ) and: [ index <= self inputCount ]! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:09'!
inputValue: inputIndex
	"Gets the input value (true or false) at the digital input with the given index."

	( self inputIndexIsInRange: inputIndex ) ifFalse: [ ^ nil ].
	( ( self primInputValue: handle at: inputIndex - 1 ) == 1 ) ifTrue: [ ^ true ].
	^ false! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:05'!
inputs
	^ inputs! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 18:42'!
onInputChangeDo: aBlock 
	"The aBlock will be evaluated when an input changed its state."
	
	userProcessBlocks 
		at: #InputChange
		put: aBlock! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 18:42'!
onOutputChangeDo: aBlock 
	"The aBlock will be evaluated when an output changed its state."
	
	userProcessBlocks 
		at: #OutputChange
		put: aBlock! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 18:42'!
onSensorChangeDo: aBlock 
	"The aBlock will be evaluated when a sensor changed its value."
	
	userProcessBlocks 
		at: #SensorChange
		put: aBlock! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:19'!
outputCount
	"Returns the number of outputs that may be attached to the Interface Kit."
	
	self attached
		ifTrue: [ ^ self primNumOutputs: handle ].
	^ 0! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 5/3/2009 11:27'!
outputIndexIsInRange: index
	"Returns true if 1<=index<=sensorCount.
	Every time a primitive is used that needs the output index, this method should be used to check if the index is in the correct range."
	
	index isInteger ifFalse: [ ^ false ].
	^ ( 1 <= index ) and: [ index <= self outputCount ]! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:19'!
outputValue: outputIndex
	"Gets the output value (true or false) at the digital output with the given index."

	( self outputIndexIsInRange: outputIndex ) ifFalse: [ ^ nil ].
	( ( self primOutputValue: handle at: outputIndex - 1 ) == 1 ) ifTrue: [ ^ true ].
	^ false! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:05'!
outputs
	^ outputs! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:01'!
primAttached: phid
	"Return 1 if the Interface Kit is attached - otherweise return 0."
	
	<primitive: 'primIfKitAttached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/12/2009 12:28'!
primClose: phid
	"Close the Interface Kit."
	
	<primitive: 'primIfKitClose' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:02'!
primCreate
	"Reset the Interface Kit (Semaphores and Handle)."

	<primitive: 'primIfKitCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/3/2009 00:05'!
primGetSensorChangeTrigger: phid at: sensorIndex
	"Gets the sensor change trigger. A sensor change will be registered if the change is higher than this number only."

	<primitive: 'primIfKitGetSensorChangeTrigger' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:37'!
primInputValue: phid at: sensorIndex
	"Gets the input value (0, 1) at the input with the given index."

	<primitive: 'primIfKitInputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/28/2009 19:05'!
primNumInputs: phid
	"Gets the number of inputs."

	<primitive: 'primIfKitNumInputs' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/28/2009 19:05'!
primNumOutputs: phid
	"Gets the number of outputs."

	<primitive: 'primIfKitNumOutputs' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:06'!
primNumSensors: phid
	"Gets the number of sensors."

	<primitive: 'primIfKitNumSensors' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/30/2009 20:12'!
primOnAttached: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when the Interface Kit is attached."
	
	<primitive: 'primIfKitOnAttached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/30/2009 20:12'!
primOnDetached: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when the Interface Kit is detached."
	
	<primitive: 'primIfKitOnDetached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/5/2009 17:14'!
primOnError: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a an Error occours. Use primLastError to get the last error code"
	
	<primitive: 'primIfKitOnError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/5/2009 17:14'!
primOnInputChanged: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when an InputValue changed."
	
	<primitive: 'primIfKitOnInputChanged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/5/2009 17:15'!
primOnOutputChanged: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when an OutputValue changed."
	
	<primitive: 'primIfKitOnOutputChanged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'lk 5/5/2009 17:15'!
primOnSensorChanged: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a SensorValue changed."
	
	<primitive: 'primIfKitOnSensorChanged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:11'!
primOpen: phid withSerial: serial
	"Opens the Interface Kit with the given serial number"

	<primitive: 'primIfKitOpen' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:11'!
primOpenAny: phid
	"Opens any available Interface Kit"

	<primitive: 'primIfKitOpenAny' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:37'!
primOutputValue: phid at: sensorIndex
	"Gets the output value (0, 1) at the output with the given index."

	<primitive: 'primIfKitOutputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:12'!
primSensorValue: phid at: sensorIndex
	"Gets the sensor value (0-1000) at the analog input with the given index."

	<primitive: 'primIfKitSensorValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/6/2009 17:12'!
primSetOutput: phid at: sensorIndex to: aNumber
	"Sets the output to  0/1 (which means ON/OFF) at the output with the given index."

	<primitive: 'primIfKitSetOutput' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'primitives' stamp: 'pt 5/3/2009 00:02'!
primSetSensorChangeTrigger: phid at: sensorIndex to: aNumber
	"Sets the sensor change trigger to  aNumber (0-1000). A sensor change will be registered if the change is higher than aNumber only."

	<primitive: 'primIfKitSetSensorChangeTrigger' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/13/2009 11:53'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding semaphores for #SensorChange, #InputChange and #OutputChange."

	| semaIndex |
	super registerSemaphores.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#SensorChange ).
	self primOnSensorChanged: handle semaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#InputChange ).
	self primOnInputChanged: handle semaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#OutputChange ).
	self primOnOutputChanged: handle semaphoreIndex: semaIndex.! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:20'!
sensitivity: sensitivity at: index 
	"Sets the input sensitivity. The onSensorChange block will be evaluated only, if the change of the sensor value is greater than the input sensitivity."
	(self sensorIndexIsInRange: index) ifFalse: [ ^ false ].
	^ self 
		primSetSensorChangeTrigger: handle
		at: index - 1
		to: sensitivity! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:20'!
sensitivityAt: index 
	"Returns the input sensitivity. The onSensorChange block will be evaluated only, if the change of the sensor value is greater than the input sensitivity."
	(self sensorIndexIsInRange: index) ifFalse: [ ^ false ].
	^ self 
		primGetSensorChangeTrigger: handle
		at: index - 1! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:20'!
sensorCount
	"Returns the number of sensors that may be attached to the Interface Kit."
	self attached
		ifTrue: [ ^ self primNumSensors: handle ].
	 ^ 0! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'pt 5/3/2009 11:27'!
sensorIndexIsInRange: index
	"Returns true if 1<=index<=sensorCount.
	Every time a primitive is used that needs the sensor index, this method should be used to check if the index is in the correct range."
	
	index isInteger ifFalse: [ ^ false ].
	^ ( 1 <= index ) and: [ index <= self sensorCount ]! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:20'!
sensorValue: sensorIndex
	"Gets the sensor value (0-1000) at the analog input with the given index."

	(self sensorIndexIsInRange: sensorIndex) ifFalse: [ ^ nil ].
	^ self primSensorValue: handle at: sensorIndex - 1! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 20:05'!
sensors
	^ sensors! !

!PhdCrInterfaceKit methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:20'!
setOutputValue: aBoolean at: outputIndex
	"Sets the output value (true or false) at the digital output with the given index."

	| anInteger |
	( self outputIndexIsInRange: outputIndex ) ifFalse: [ ^ nil ].
	aBoolean
		ifTrue: [ anInteger := 1 ]
		ifFalse: [ anInteger := 0 ].
	^ self primSetOutput: handle at: outputIndex-1 to: anInteger.! !

!PhdCrPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:23'!
knownCallbacks
	"Returns a list of callback names (#symbols) the Phidget knows"
	
	^ #( #Attach #Detach #Error )! !

!PhdCrPhidget class methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 17:04'!
systemCallbacks
	"This Method answers a Doctionary similar to the instance's userProcessBlocks.
	It may for instance contain message selectors sent when attaching or detaching a phidget, so the phidget components can be initialized."
	
	SystemCallbacks ifNotNil: [ ^ SystemCallbacks ].
	
	SystemCallbacks := Dictionary new.
	SystemCallbacks
		add: #Attach -> #initializeComponents;
		add: #Detach -> #deleteComponents.
	^ SystemCallbacks! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 11:29'!
attached
	"Returns true if the Phidget is attached, and false otherwise."
	
	( ( self primAttached: handle ) == 1 ) ifTrue: [ ^ true ].
	^ false! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:25'!
callbackProcess: callbackName 
	"This method will be forked as an extra process for every callback that a phidget needs.
	The semaphores were previously initialised and registered as external objects.
	self class knownCallbacks lists all possible semaphore names.
	systemCallbacks contain message selectors to be sent."
	(semaphores at: callbackName) wait.
	[ opened ] whileTrue: 
		[ (self class systemCallbacks includesKey: callbackName) ifTrue: [ self perform: (self class systemCallbacks at: callbackName) ].
		(userProcessBlocks at: callbackName) value.
		(semaphores at: callbackName) wait ]! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 21:50'!
checkHandle
	"Checks if a handle is attached"
	
	^ handle isNil not! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:38'!
close
	"Close the Phidget."

	opened ifFalse: [^ self]. "already closed"
	self primClose: handle.
	
	opened := false.
	self
		unregisterSemaphores;
		deleteComponents.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 00:47'!
createCallbackProcessBlock: callbackName
	"Create a callback process block to be forked.
	Must be swapped out to work in loops."

	^ [ self callbackProcess: callbackName ]! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:41'!
deleteComponents
	"This method is called when a Phidget is detached. It should delete previously in 'initializeComponents' built components, e.g. outputs, sensors, ...
	The abstract phidget does not have components, so it does nothing here."! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:05'!
forkCallbacks
	"Fork the callback processes."
	
	self class knownCallbacks do: [ :callbackName |
		(self createCallbackProcessBlock: callbackName) fork ].! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:13'!
initialize
	"Initialise the callbacks that are used in every Phidget.
	Every subclass should call super initialise or initialise the callbacks by their own.
	In addition mark phidget as opened and create the representation in the plugin using a primitive."
	super initialize.
	semaphores := Dictionary new.
	userProcessBlocks := Dictionary new.
	self class knownCallbacks do: 
		[ :name | 
		semaphores add: name -> Semaphore new.
		userProcessBlocks add: name -> [  ] ].
	opened := false.
	handle := self primCreate! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:41'!
initializeComponents
	"This method is called when a Phidget is attached. It should initialize its components (sensors, outputs, ...).
	The components will be deleted in 'deleteComponents' on detaching.
	The abstract phidget does not have components, so it does nothing here."! !

!PhdCrPhidget methodsFor: 'testing' stamp: 'lk 5/31/2009 21:51'!
isOpen

	^ opened! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'pt 5/2/2009 22:10'!
lastError
	"Returns the error code of the last error.
	Descriptions of the codes may be found on www.phidgets.com or phidget21.h on line 2250 ff."

	^ self primLastError! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 19:09'!
on: callbackName do: aBlock 
	"aBlock will be evaluated when the semaphore at callbackName is signaled."
	
	(self class knownCallbacks includes: callbackName) ifTrue: [
		userProcessBlocks 
			at: callbackName
			put: aBlock ].! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:13'!
onAttachDo: aBlock 
	"The aBlock will be evaluated if the phidget was attached."
	userProcessBlocks 
		at: #Attach
		put: aBlock! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:13'!
onDetachDo: aBlock 
	"The aBlock will be evaluated if the phidget was detached."
	userProcessBlocks 
		at: #Detach
		put: aBlock! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:13'!
onErrorDo: aBlock 
	"The aBlock will be evaluated if an error occoured with the phidget."
	userProcessBlocks 
		at: #Error
		put: aBlock! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/29/2009 12:17'!
openAny
	"Opens any Phidget."
	
	self checkHandle ifFalse: [ ^ self ].
	self
		registerSemaphores;
		primOpenAny: handle.
	opened := true.
	self forkCallbacks.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/29/2009 12:17'!
openSpecefic: serialNumber
	"Opens the Phidget with the given serial number."
	
	self checkHandle ifFalse: [ ^ self ].
	self
		registerSemaphores;
		primOpen: handle
		withSerial: serialNumber.
	opened := true.
	self forkCallbacks.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 11:31'!
primAttached: aPhidgetHandle
	"Returns true if the Phidget is attached, and false otherwise."
	
	self subclassResponsibility.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 11:32'!
primClose: aPhidgetHandle
	"Close the connection to the Phidget."
	
	self subclassResponsibility.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 11:57'!
primCreate
	"Reset the Phidget (Semaphores and Handle)."
	
	self subclassResponsibility.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'pt 5/2/2009 22:10'!
primLastError
	"Returns the error code of the last error.
	Descriptions of the codes may be found on www.phidgets.com or phidget21.h on line 2250 ff."

	<primitive: 'primLastError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:07'!
primOpen: phid withSerial: serial
	"Opens the Phidget with the given serial number"

	self subclassResponsibility.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:06'!
primOpenAny: phid
	"Opens any available Phidget"

	self subclassResponsibility.! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'lk 5/13/2009 11:51'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. May be extended in subclasses."

	| semaIndex |
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#Attach ).
	self primOnAttached: handle semaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#Detach ).
	self primOnDetached: handle semaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#Error ).
	self primOnError: handle semaphoreIndex: semaIndex.! !

!PhdCrPhidget methodsFor: 'testing' stamp: 'lk 5/31/2009 21:53'!
testSemaphoresReset
	"Answer true if the semaphores are reset, false otherwise."
	
	handle do: [ :byte |
		byte isZero ifFalse: [^ false] ].
	^ true! !

!PhdCrPhidget methodsFor: 'as yet unclassified' stamp: 'pt 5/2/2009 22:16'!
unregisterSemaphores
	"Unregister the semaphores which were previously registered with 'self registerSemaphores'."

	semaphores do: [ :sema |
		sema signal.
		Smalltalk unregisterExternalObject: sema ]! !

PhdCrPhidget subclass: #PhdCrRFID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrRFID commentStamp: 'lk 6/1/2009 17:12' prior: 0!
I am a representation of a Phidget called 'Phidget RFID' in Squeak.
To use the RFID Phidget, create a new instance and open a connection to the hardware board with:
	rfid := PhdCrRFID new.
	rfid openAny.
A block can be set to be evaluated every time the hardware board was attached, detached, an error occoured, an output value was changed, a tag was found by the RFID reader, or if the tag was lost. For example:
	rfid
		onAttachDo: [ Transcript show:'rfid was attached!!';cr ];
		onDetachDo: [ Transcript show:'rfid was detached!!';cr ];
		onTagFoundDo: [ Transcript show:'rfid found a tag';cr ].

The RFID antenna is needed to read tags near the Phidget. Send 'setAntennaState: true' to turn it on (false to turn it off).
To get a tag currently read by the reader send 'getCurrentTag' or 'getCurrentTagBytes' (latter will give you an array identifying the tag, first will give you a string of hexadecimal values representing the array). You can also find out which tag was read last without regard if it is still read. Use 'getLastTag' or 'getLastTagBytes'.
To illuminate the on-board LED send 'setLedState: true', (false to turn off). You can get the current state of the LED by sending 'isLedOn'.
Depending on which hardware is attached it is possible to attach zero or more digital outputs to the board. To get the number of available outputs send 'outputCount'. Every output can be accessed by an index adressing it. Valid indices are greater or equal than 1 and less or equal than the number of available outputs (outputCount).
The output values are boolean and may be read by: 'outputValue: index'. Set an output value to true/false with 'setOutputValue: aBoolean at: index'.

IMPORTANT:
After using the RFID Phidget it is important to close the connection to the hardware by sending 'close':
	rfid close.

NOTE:
The antenna might be enabled/disabled from the last use of the Phidget. If you do not get a signal, test the antenna state.

NICE EXAMPLE ;) (indicating if a tag was found using the LED)
	rfid := PhdCrRFID new.
	rfid
		onAttachDo: [ rfid setAntennaState: true ];
		onTagFoundDo: [ rfid setLedState: true ];
		onTagLostDo: [ rfid setLedState: false ];
		openAny.
	"Now hold a tag near the Phidget and then take it away."
	rfid close.!

!PhdCrRFID class methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:03'!
knownCallbacks
	"Returns a list of callback names (#symbols) the RFID Phidget knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #OutputChange #TagFound #TagLost )! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 17:24'!
deleteComponents
	"This method is called when the RFID Phidget is detached. It delets previously in 'initializeComponents' built components: rfidSensor, outputs, led"

	Transcript show: 'deleteComponents'; cr.! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 19:38'!
getCurrentTag
	"Returns a string which represents a hex-value of the 5 bytes tag ID of the tag currently read.
	If there is no tag currently read, return nil."
	
	^ self hasTag
		ifTrue: [ self getLastTag ]
		ifFalse: [ nil ]! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 19:40'!
getCurrentTagBytes
	"Returns a byte array with the 5 elements of the tag ID currently read.
	If there is no tag currently read, return nil."
	
	^ self hasTag
		ifTrue: [ self getLastTagBytes ]
		ifFalse: [ nil ]! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 19:41'!
getLastTag
	"Returns a string which represents a hex-value of the 5 bytes tag ID.
	This tag may or may not still be on the reader.
	If there was no tag read by the reader since opened, the method returns a string with 10 zeros."
	
	| aString |
	aString := ''.
	self getLastTagBytes do: [ :byte | 
		aString := aString , byte hex ].
	^ aString! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 19:40'!
getLastTagBytes
	"Returns a byte array with the 5 elements of the tag ID.
	This tag may or may not still be on the reader.
	If there was no tag read by the reader since opened, the method returns a Byte array with zeros."
	
	self attached ifFalse: [ ^ nil ].
	^ self primGetLastTag: handle! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 18:44'!
hasTag
	"Returns true is a tag is currently connected and false if not."
	
	self attached ifFalse: [ ^ false ].
	^ (self primHasTag: handle) > 0! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 17:23'!
initializeComponents
	"This method is called when a RFID Phidget is attached. It initializes its components: rfidSensor, outputs, led.
	The components will be deleted in 'deleteComponents' on detaching."
	
	Transcript show: 'initializeComponents'; cr.! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 18:44'!
isAntennaOn
	"Answer true if the antenna is on, false otherwise."
	
	self attached ifFalse: [ ^ false ].
	^ (self primIsAntennaOn: handle) > 0! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 18:44'!
isLedOn
	"Answer true if the on-board LED is on, else false."
	
	self attached ifFalse: [ ^ false ].
	^ (self primIsLedOn: handle) > 0! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:13'!
onOutputChangeDo: aBlock 
	"The aBlock will be evaluated if an output changed its state."
	userProcessBlocks 
		at: #OutputChange
		put: aBlock! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:13'!
onTagFoundDo: aBlock 
	"The aBlock will be evaluated when a tag was found."
	userProcessBlocks 
		at: #TagFound
		put: aBlock! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:13'!
onTagLostDo: aBlock 
	"The aBlock will be evaluated when a tag was lost."
	userProcessBlocks 
		at: #TagLost
		put: aBlock! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:06'!
outputCount
	"Returns the number of outputs that may be attached to the Interface Kit."
	
	self attached
		ifTrue: [ ^ self primNumOutputs: handle ].
	^ 0! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:06'!
outputIndexIsInRange: index
	"Returns true if 1<=index<=sensorCount.
	Every time a primitive is used that needs the output index, this method should be used to check if the index is in the correct range."
	
	index isInteger ifFalse: [ ^ false ].
	^ ( 1 <= index ) and: [ index <= self outputCount ]! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:07'!
outputValue: outputIndex
	"Gets the output value (true or false) at the digital output with the given index."

	( self outputIndexIsInRange: outputIndex ) ifFalse: [ ^ nil ].
	( ( self primOutputValue: handle at: outputIndex - 1 ) == 1 ) ifTrue: [ ^ true ].
	^ false! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:10'!
primAttached: phid
	"Return 1 if the RFID Phidget is attached - otherweise return 0."
	
	<primitive: 'primRFIDAttached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:10'!
primClose: phid
	"Close the RFID Phidget."
	
	<primitive: 'primRFIDClose' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:11'!
primCreate
	"Reset the RFID Phidget (Semaphores and Handle)."

	<primitive: 'primRFIDCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 18:59'!
primGetLastTag: phid

	<primitive: 'primRFIDGetLastTag' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 18:31'!
primHasTag: phid
	
	<primitive: 'primRFIDHasTag' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:45'!
primIsAntennaOn: phid
	"Answer true if the antenna is on, else false."
	
	<primitive: 'primRFIDIsAntennaOn' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:31'!
primIsLedOn: phid
	"Answer true if the on-board LED is on, else false."
	
	<primitive: 'primRFIDIsLedOn' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:11'!
primNumOutputs: phid
	"Gets the number of outputs."

	<primitive: 'primRFIDNumOutputs' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:12'!
primOnAttached: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when the RFID Phidget is attached."
	
	<primitive: 'primRFIDOnAttached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:12'!
primOnDetached: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when the RFID Phidget is detached."
	
	<primitive: 'primRFIDOnDetached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:12'!
primOnError: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a an Error occours. Use primLastError to get the last error code"
	
	<primitive: 'primRFIDOnError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:05'!
primOnOutputChanged: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when an output value changed."
	
	<primitive: 'primRFIDOnOutputChanged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:05'!
primOnTagFound: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a tag was found."
	
	<primitive: 'primRFIDOnTagFound' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:05'!
primOnTagLost: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a tag was lost."
	
	<primitive: 'primRFIDOnTagLost' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:13'!
primOpen: phid withSerial: serial
	"Opens the RFID Phidget with the given serial number"

	<primitive: 'primRFIDOpen' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 21:07'!
primOpenAny: phid
	"Opens any available RFID Phidget"

	<primitive: 'primRFIDOpenAny' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:07'!
primOutputValue: phid at: sensorIndex
	"Gets the output value (0, 1) at the output with the given index."

	<primitive: 'primRFIDOutputValue' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 21:09'!
primSetAntennaState: phid to: state
	"Set the state of the antenna to true (state=1) or false (state=0)."
	
	<primitive: 'primRFIDSetAntennaState' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:41'!
primSetLedState: phid to: state
	"Set the state of the on-board LED to true (state=1) or false (state=0)."
	
	<primitive: 'primRFIDSetLedState' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:07'!
primSetOutput: phid at: sensorIndex to: aNumber
	"Sets the output to  0/1 (which means ON/OFF) at the output with the given index."

	<primitive: 'primRFIDSetOutput' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:04'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding semaphores for #OutputChange, #TagFound and #TagLost."

	| semaIndex |
	super registerSemaphores.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#OutputChange ).
	self primOnOutputChanged: handle semaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#TagFound ).
	self primOnTagFound: handle semaphoreIndex: semaIndex.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#TagLost ).
	self primOnTagLost: handle semaphoreIndex: semaIndex.! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 18:47'!
setAntennaState: aBoolean
	"Sets the state of the antenna to true or false.
	The antenna must be enabled in order to find tags near the Phidget."

	| anInt |
	self attached ifFalse: [ ^ nil ].
	aBoolean
		ifTrue:  [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ self primSetAntennaState: handle to: anInt! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 18:47'!
setLedState: aBoolean
	"Sets the state of the on-board LED to true or false.
	true meens the LED is illuminated, false that it is not."

	| anInt |
	self attached ifFalse: [ ^ nil ].
	aBoolean
		ifTrue:  [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	^ self primSetLedState: handle to: anInt! !

!PhdCrRFID methodsFor: 'as yet unclassified' stamp: 'lk 5/31/2009 18:47'!
setOutputValue: aBoolean at: outputIndex
	"Sets the output value (true or false) at the digital output with the given index."

	| anInteger |
	self attached ifFalse: [ ^ nil ].
	( self outputIndexIsInRange: outputIndex ) ifFalse: [ ^ nil ].
	aBoolean
		ifTrue: [ anInteger := 1 ]
		ifFalse: [ anInteger := 0 ].
	^ self primSetOutput: handle at: outputIndex-1 to: anInteger! !

PhdCrPhidget subclass: #PhdCrServo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Core'!

!PhdCrServo commentStamp: 'lk 6/1/2009 17:12' prior: 0!
I am a representation of a Phidget called 'Servo' (here: 'Servo board') in Squeak.
To use the Servo board, create a new instance and open a connection to the hardware board with:
	servo := PhdCrServo new.
	servo openAny.
A block can be set to be evaluated every time the hardware board was attached, detached, an error occoured or the position of a motor was changed. For example:
	servo
		onAttachDo: [ Transcript show:'servo was attached!!;cr' ];
		onDetachDo: [ Transcript show:'servo was detached!!;cr' ];
		onPositionChangeDo: [ Transcript show:'A motor changed it's position!!' ].
Depending on which hardware is attached it is possible to attach one or more servo motors to the board. To get the number of available motors send 'motorCount'. Every motor can be accessed by an index adressing the motor. Valid indices are greater or equal than 1 and less or equal than the number of available motors (motorCount).
To set the position of a motor to a value, call 'setMotorPosition: aFloat at: index' (aFloat must be between minMotorPositionAt: index and maxMotorPositionAt: index !!).

IMPORTANT:
After using the servo it is important to close the connection to the hardware by sending 'close':
	servo close.
!

!PhdCrServo class methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:23'!
knownCallbacks
	"Returns a list of callback names (#symbols) the Servo knows.
	This extends the list the super class knows."
	
	^ super knownCallbacks, #( #PositionChange )! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 17:25'!
deleteComponents
	"This method is called when the Servo is detached. It delets previously in 'initializeComponents' built components: motors"

	Transcript show: 'deleteComponents'; cr.! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 5/30/2009 20:51'!
getEngagedAt: index 
	"Returns the engaged state of a motor. This is whether the motor is powered or not."
	
	(self indexIsInRange: index) ifFalse: [ ^ self ].
	^ (self 
		primGetEngaged: handle
		at: index - 1) == 1! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'pt 5/3/2009 11:26'!
indexIsInRange: index 
	"Returns true if 1<=index<=motorCount.
	Every time a primitive is used that needs the motor index, this method should be used to check if the index is in the correct range."
	index isInteger ifFalse: [ ^ false ].
	^ 1 <= index and: [ index <= self motorCount ]! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 17:26'!
initializeComponents
	"This method is called when an Servo Phidget is attached. It initializes its components: motors.
	The components will be deleted in 'deleteComponents' on detaching."
	
	Transcript show: 'initializeComponents'; cr.! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 5/14/2009 21:36'!
maxMotorPositionAt: index 
	"Returns the max. allowed motor position for the motor attached at the given index."
	
	(self indexIsInRange: index) ifFalse: [ ^ 0 ].
	^ self 
		primGetPositionMax: handle
		at: index - 1! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 5/14/2009 21:36'!
minMotorPositionAt: index 
	"Returns the min. allowed motor position for the motor attached at the given index."
	(self indexIsInRange: index) ifFalse: [ ^ 0 ].
	^ self 
		primGetPositionMin: handle
		at: index - 1! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:21'!
motorCount
	"Returns the number of motors that may be attached to the Servo board."
	
	self attached
		ifTrue: [ ^ self primNumMotors: handle ].
	^ 0! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 5/14/2009 21:36'!
motorPositionAt: index 
	"Returns the current position of the motor attached at the given index."
	(self indexIsInRange: index) ifFalse: [ ^ 0 ].
	^ self 
		primGetPosition: handle
		at: index - 1! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 6/1/2009 12:13'!
onPositionChangeDo: aBlock 
	"The aBlock will be evaluated if the position of a motor was changed."
	userProcessBlocks 
		at: #PositionChange
		put: aBlock! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'pt 5/4/2009 15:31'!
positionIsInRange: position at: index 
	"The position is in range, if the index is in range and the position is between the min. and max. Position."
	(self indexIsInRange: index) ifFalse: [ ^ false ].
	(self maxMotorPositionAt: index) >= position ifFalse: [ ^ false ].
	(self minMotorPositionAt: index) <= position ifFalse: [ ^ false ].
	^ true! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/28/2009 19:11'!
primAttached: phid
	"Return 1 if the Servo board is attached - otherwise return 0."

	<primitive: 'primServoAttached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:24'!
primClose: phid
	"Close the connection to the Servo board."

	<primitive: 'primServoClose' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:24'!
primCreate
	"Reset the Servo board (Semaphores and Handle)."

	<primitive: 'primServoCreate' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'pt 5/2/2009 22:21'!
primGetEngaged: phid at: index
	"Returns 1 if the motor on the given index is engaged - otherwise return 0.
	This is whether the motor is powered or not."

	<primitive: 'primServoGetEngaged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/14/2009 21:35'!
primGetPosition: phid at: index
	"Returns a float containing the position of the motor at the given index."

	<primitive: 'primServoGetPosition' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/14/2009 21:34'!
primGetPositionMax: phid at: index
	"Returns a float containing max. possible position of the motor at the given index."

	<primitive: 'primServoGetPositionMax' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/14/2009 21:35'!
primGetPositionMin: phid at: index
	"Returns a float containing min. possible position of the motor at the given index."

	<primitive: 'primServoGetPositionMin' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:24'!
primNumMotors: phid
	"Returns the number of motors that can be attached to the Servo board."

	<primitive: 'primServoNumMotors' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/5/2009 17:16'!
primOnAttached: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when the servo board becomes attached."
	
	<primitive: 'primServoOnAttached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/5/2009 17:16'!
primOnDetached: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when the Servo board becomes detached."
	
	<primitive: 'primServoOnDetached' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/5/2009 17:16'!
primOnError: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a an Error occours. Use primLastError to get the last error code"
	
	<primitive: 'primServoOnError' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/5/2009 17:16'!
primOnPositionChanged: phid semaphoreIndex: semaIndex
	"registers the given Semaphore to be signaled when a motor changes its position."
	
	<primitive: 'primServoOnPositionChanged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:26'!
primOpen: phid withSerial: serial
	"Opens the Servo board with the given serialNumber."

	<primitive: 'primServoOpen' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'pt 5/2/2009 23:26'!
primOpenAny: phid
	"Opens any available Servo board."

	<primitive: 'primServoOpenAny' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'pt 4/28/2009 10:13'!
primSetEngaged: phid at: index to: value
	"Sets the engaged state of the motor at the given index to <value>. Value must be 0 or 1!!
	This is whether the motor is powered or not."

	<primitive: 'primServoSetEngaged' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'primitives' stamp: 'lk 5/14/2009 21:38'!
primSetPosition: phid at: index to: aFloat
	"Set the position of the motor at the given index to aFloat. aFloat must be between primGetPositionMin and primGetPositionMax."

	<primitive: 'primServoSetPosition' module: 'PhidgetPlugin'>
	^ nil! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 5/13/2009 11:54'!
registerSemaphores
	"Register the semaphores, so that the PhidgetPlugin can signal them. Extends the superclasses' method by adding a semaphore for #PositionChange."

	| semaIndex |
	super registerSemaphores.
	semaIndex := Smalltalk registerExternalObject: ( semaphores at:#PositionChange ).
	self primOnPositionChanged: handle semaphoreIndex: semaIndex.! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 5/12/2009 12:21'!
setEngaged: aBoolean at: index 
	"Sets the engaged state of a motor. This is whether the motor is powered or not."
	| anInt |
	(self indexIsInRange: index) ifFalse: [ ^ self ].
	aBoolean 
		ifTrue: [ anInt := 1 ]
		ifFalse: [ anInt := 0 ].
	self 
		primSetEngaged: handle
		at: index - 1
		to: anInt! !

!PhdCrServo methodsFor: 'as yet unclassified' stamp: 'lk 5/14/2009 21:39'!
setPosition: aValue at: index
	"Set the position of the motor attached at <index> to <aValue>.
	aValue should be a float betwenn the min. and max. motor position."

	| aFloat |
	aFloat := aValue asFloat.
	( self positionIsInRange: aFloat at: index ) ifFalse: [ ^ self ].
	^ self primSetPosition: handle at: index - 1 to: aFloat! !
